//toolbar 虚表工具栏
//光庆封装
//1.2
//2025-02-01

import godking.vlistEx
namespace godking.vlistEx
	
class toolbar{
	ctor(vlist,config,itemlist,...){
		this.config = ..table.assign({	bkcolor = 0xFFFFFF;
										bkimage = null;
										cellwidth = 50;
										cellheight = 90;
       									imgpadding = 10;
        								textpadding = 5; 
     									font={name="宋体",h=14,color=0xFF000000};
    									hoverfont={name="宋体",h=14,color=0xFFFF0000};
										},config);
		var textpadding = this.config.textpadding;
		var imgpadding = this.config.imgpadding;
		var fonth = ..math.max(this.config.font.h,this.config.hoverfont.h);
		var itemModel = {
    		{   type = "img";
        		name = "img";
        		rectf = {x=imgpadding,y=imgpadding,width=-imgpadding,height=-(textpadding*2+fonth+4)};
        		hover = true;
        		scale = true;
    		}
    		{   type = "text";
        		name = "text";
        		rectf = {x=1,y=-(textpadding*2+fonth+4),width=-1,height=textpadding*2+fonth};
        		font = this.config.font;
        		itemhoverfont = this.config.hoverfont;
        		hover = true;
        		align = 1;
        		valign = 1;
    		}
		}
		var resetVlist = function(){
			if !#this.itemlist return ;
				var vlistwidth,cellwidths= 0,{};
				var list = this.itemlist[1];
				for(i=1;#this.itemlist;1){
					if #this.itemlist[i]>#list list = this.itemlist[i];
				}
				for(i=1;#list;1){
					var w;
					if list[i] === "|" {
						w = ..math.floor(this.config.cellwidth/3);
					} else {
						w = this.config.cellwidth;
					}
					vlistwidth += w;
					..table.push(cellwidths,w);
				}
				var dpi = ..godking.vlistEx.getDpi();
				vlist.width = vlistwidth*dpi;
				vlist.height = (this.config.cellheight+1)*#this.itemlist*dpi;
 				vlist.setTable(this.itemlist /*数据表*/,/*列标题*/,cellwidths/*列宽*/,/*0左1中2右*/,/*字典转为数组*/,/*字符串转为Utf8*/,/*是否克隆新表*/);
				vlist.setColumnType(/*列号*/,7/*_vlistEx_ColType_OwnerDrawCustom*/,itemModel/*参考godking.customPlus中的itemModel定义规则*/ );
				vlist.hideScroll(true/*隐藏横向滚动条*/,true/*隐藏纵向滚动条*/);
				vlist.setHeaderHeight(0);
				vlist.setRowHeight(this.config.cellheight);
		}
		vlist.lineWidthV = null;
		vlist.selectedBkColor = null;
		vlist.padding = 0;
		vlist.bkColor = this.config.bkcolor;
		vlist.blankColor = this.config.bkcolor;
		vlist.lineColorH = this.config.lineColorH;

		this.setItemList = function(itemlist,...){
			if type(itemlist)!==type.table return ; 
			if ... {
				this.itemlist = ..table.clone({itemlist,...});
			} elseif type(itemlist[[1]])!==type.table {
				this.itemlist={..table.clone(itemlist)}
			} else {
				this.itemlist = ..table.clone(itemlist);
			}
			resetVlist();
		}
		this.setItemList(itemlist,...);
		vlist.onDrawCellRectBg = function(row,col,hdc,rect,bkcolor,text){
			if !this.config.bkimage return ; 
			if this.config.bkcolor!==null {
				..gdi.fillRect(hdc,this.config.bkcolor,rect)
			}
			var bmp = vlist.getImg(this.config.bkimage,true,true);
			if bmp {
				var gra = ..gdip.graphics(hdc);
				gra.setClipRect(rect.xywh());
				gra.drawImage(bmp);
				gra.delete();
			}
			return true; 
		}
		vlist.onDrawCellRectContent = function(row,col,hdc,rect,bkcolor,text){
			if text==="|" or  text==="||" {
				if this.config.lineColorV!==null {
					var x = (rect.left+rect.right)/2;
					..gdi.selectPen(
						function(hdc,pen){
							..gdi.drawLine(hdc,x,rect.top+this.config.textpadding*2,x,rect.bottom-this.config.textpadding*2-4);
						},hdc,this.config.lineColorV,0x000000);
				}
				return true;
			}
		}
		vlist.ownerDrawCustom = function (row,col,text/*当前单元格文本*/){
			if  text==="|"  or  text==="||" return ; 
    		var s = ..string.split(text,"|");
    		return  {    img={
                    		img = s[[1]];
                    		itemhoverimg = s[[2]];
                		};
                		text = s[[3]];
            		}; 
		}
		vlist.onClick = function(row/*行*/,col/*列*/,x,y,buttonIndex/*按钮序号*/){
			if row and col {
				var text = vlist.getCellText( row/*行号*/,col/*列号或字典key*/);
				if  text==="|"  or  text==="||" return ; 
				var ts = ..string.split(text,"|");
				if ts[[3]] and this.onClick {
        			this.onClick(row,col,ts[[3]]);
    			}
    		}
		}		
	}
	addImg = function(picname,imgdata,w,h){
		return vlist.addImg(picname,imgdata,false/*是否替换*/,w,h);
	}
	redraw = function(){
		vlist.redrawRow(1 /*开始行*/,1/*结束行*/);
	}
}

namespace toolbar {
		
}

/*****intellisense()
godking.vlistEx.toolbar = 虚表工具栏。
godking.vlistEx.toolbar(__ /*虚表*/,/*项目设置表*/,.../*可以有多个项目设置表*/) = @.toolbar(winform.vlistEx,{
        bkcolor = 0xFFFFFF; 	/*表格背景颜色*/
        bkimage = null;  		/*表格背景图片*/
        cellwidth = 60;      	/*单元格宽度*/
        cellheight = 80;    	/*单元格高度*/
        imgpadding = 10;		/*单元格图片空白边距*/
        textpadding = 5;        /*单元格文本空白边距*/
        font={name="宋体",h=12,color=0xFF000000};         /*正常字体*/
        hoverfont={name="宋体",h=12,color=0xFFFF0000};    /*鼠标划过字体*/
        lineColorH = 0xBBBBBB;    /*底部横线颜色。null则无底部横线。*/
        lineColorV = 0xCCCCCC;    /*竖向分隔线颜色。null则无分隔线。*/
})
addImg("__"/*图片名称*/,img/*图片文件*/,/*宽度*/,/*高度*/) = 添加图片，以供单元格调用。{
    参数：
    1、图片名称（必填）。
    2、图片文件（必填）。支持图片数据、bitmap对象、本地文件名、http文件地址。
    3、图片宽度。null则使用图片原宽度。
    4、图片高度。null则使用图片原高度。
    注意：
    1、尽量设置合适的大小，以加快表格刷新速度。
    2、添加后返回图片的bitmap对象，添加失败返回null。
}
setItemList() = @.setItemList({	
		/* 项目设置表。格式为：正常图片名称|划过图片名称|项目文本。
		   竖向分割线格式为："|"：窄列宽(正常列宽的1/3)；"||"：正常列宽。
		   项目设置表可以为数组，或多个参数。每个设置表为一行。
		   以项目最多的行作为参考设置列数及列宽。多行且上下行的分割线不对齐的情况下，建议用"||"代替"|"*/
		"img1|img2|打开",
		"|",
        "img2|img3|编辑",
        "||",
        "img4|img5|关于"
})
redraw() = 刷新显示
onClick() = @.onClick = function(row/*行号*/,col/*列号*/,text/*项目文本*/){
	__
}
end intellisense*****/
